; This version was successfully test flown on 5/2/2000

; Newer version to consider. This uses RA2 as an output. When high, this enables
; an extra output which switches on an external power source to light up the glow plug.

#ifdef	__16F84
	LIST P=16F84

	include P16F84.INC
	__config	_CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC
WSAVE	equ	45
STSAVE	equ	46
#endif

#ifdef	__16F84A
	LIST P=16F84A

	include P16F84A.INC
	__config	_CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC
WSAVE	equ	45
STSAVE	equ	46
#endif

#ifdef	__16C620A
	LIST P=16C620A

	include P16C620A.INC
	__config	_CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC & _BODEN_OFF
WSAVE	equ	0x60
STSAVE	equ	0x61
#endif

#ifdef	__16CE625
	LIST P=16CE625

	include P16CE625.INC
	__config	_CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC & _BODEN_OFF
WSAVE	equ	0x70
STSAVE	equ	0x71
#endif


#define	V2	1

; Bits in PORT B
#define	IPBIT	0
#define	OPBIT	1
#define	MODEBIT	2
#define	IDLE0	4
#define	IDLE1	5
#define	SCALE	6
#define	REVERSE	7
#define	TRISASET	0x1B
#define	TRISBSET	0xFD

; Bits in PORT A
#define	GPON	2

OTIMELO	EQU	32
OTIMEHI	EQU	33
COUNTER	EQU	34
INPUTLO	EQU	35
INPUTHI	EQU	36
CRESHI	EQU	37
INERROR	EQU	38
ERCOUNT	EQU	39

TIMEH_A	equ	40
TIMEH_B	equ	41

STIME_L	equ	42
STIME_H	equ	43

MODE	equ	44

; gap at 45 and 46 for 16F84   WSAVE and STSAVE

TIMDONE	equ	47
Accl	equ	48
Acch	equ	49
Accx	equ	50
gpl	equ	51
gph	equ	52

; Intsave	equ	51

	org	0
	movlw	0x20		; first ram location address
	movwf	FSR
	clrf	INTCON
	goto	start

	org	4
interrupt:
	movwf	WSAVE			; save W reg
	swapf	STATUS,W		; get status reg
	movwf	STSAVE			; save status (swapped)
	swapf	WSAVE,F			; swap it ready for return

	movf	MODE,W			; what are we doing?
	andlw	0x01
	addwf	PCL,F			; switch to the required code
	goto	m0
	goto	m1

; m0 - start timing input pulse
m0:
	movf	TMR0,W
	movwf	STIME_L
	movf	TIMEH_A,W
	movwf	STIME_H
	bcf	INTCON,INTF
	movlw	0x0F		; falling edge
	option
	incf	MODE,F
	btfss	INTCON,T0IF
	goto	intdone_enable
; Now we sort out the high byte
	btfsc	STIME_L,7
	goto	intdone_enable
	incf	TIMEH_B,W
	movwf	STIME_H
	goto	intdone_enable

;----------------
m1:
	movf	TMR0,W
	movwf	INPUTLO
	movf	TIMEH_A,W
	movwf	INPUTHI
	bcf	INTCON,INTF
	movlw	0x4F		; rising edge
	option

	btfss	INTCON,T0IF
	goto	m1end
; Now we sort out the high byte
	btfsc	INPUTLO,7
	goto	m1end
	incf	TIMEH_B,W
	movwf	INPUTHI
m1end:
	movf	STIME_H,W
	subwf	INPUTHI,F
	movf	STIME_L,W
	subwf	INPUTLO,F
	SKPC
	decf	INPUTHI,F
	bsf	TIMDONE,0

intdone_disable:
	swapf	STSAVE,W		; unswap saved status
	movwf	STATUS			; put it back
	swapf	WSAVE,W			; get W reg back, without changing status bits
	return

intdone_enable:
	swapf	STSAVE,W		; unswap saved status
	movwf	STATUS			; put it back
	swapf	WSAVE,W			; get W reg back, without changing status bits
	retfie

; Parameter set up

#define	LOWLIMITA	900
#define	LOWLIMITB	700
#define	HILIMITA	2100
#define	HILIMITB	2300


; Bits are :- REVERSE SCALE LO1 LO0
;Value	minp	maxp	defp
;0000	900	2100	1000
;0001	900	2100	1150
;0010	900	2100	1200
;0011	900	2100	1250
;0100	700	2300	0800
;0101	700	2300	0900
;0110	700	2300	1000
;0111	700	2300	1100
;1000	900	2100	2000
;1001	900	2100	1850
;1010	900	2100	1800
;1011	900	2100	1750
;1100	700	2300	2200
;1101	700	2300	2100
;1110	700	2300	2000
;1111	700	2300	1900

; And for alternative mode (mid position)
; Bits are :- REVERSE SCALE LO1 LO0
;Value	minp	maxp	defp
;0000	900	2100	1800
;0001	900	2100	1700
;0010	900	2100	1600
;0011	900	2100	1500
;0100	700	2300	1920
;0101	700	2300	1780
;0110	700	2300	1640
;0111	700	2300	1500
;1000	900	2100	1200
;1001	900	2100	1300
;1010	900	2100	1400
;1011	900	2100	1500
;1100	700	2300	1080
;1101	700	2300	1220
;1110	700	2300	1360
;1111	700	2300	1500


getparam:
	btfss	PORTB,MODEBIT
	goto	midpos

	addwf	PCL,F
	retlw	1000 & 0xFF
	retlw	1000 >> 8

	retlw	1150 & 0xFF
	retlw	1150 >> 8

	retlw	1200 & 0xFF
	retlw	1200 >> 8

	retlw	1250 & 0xFF
	retlw	1250 >> 8

	retlw	 800 & 0xFF
	retlw	 800 >> 8

	retlw	 900 & 0xFF
	retlw	 900 >> 8

	retlw	1000 & 0xFF
	retlw	1000 >> 8

	retlw	1100 & 0xFF
	retlw	1100 >> 8
	
	retlw	2000 & 0xFF
	retlw	2000 >> 8

	retlw	1850 & 0xFF
	retlw	1850 >> 8

	retlw	1800 & 0xFF
	retlw	1800 >> 8

	retlw	1750 & 0xFF
	retlw	1750 >> 8

	retlw	2200 & 0xFF
	retlw	2200 >> 8

	retlw	2100 & 0xFF
	retlw	2100 >> 8

	retlw	2000 & 0xFF
	retlw	2000 >> 8

	retlw	1900 & 0xFF
	retlw	1900 >> 8

midpos:
	addwf	PCL,F
	retlw	1800 & 0xFF
	retlw	1800 >> 8

	retlw	1700 & 0xFF
	retlw	1700 >> 8

	retlw	1600 & 0xFF
	retlw	1600 >> 8

	retlw	1500 & 0xFF
	retlw	1500 >> 8

	retlw	1920 & 0xFF
	retlw	1920 >> 8
	
	retlw	1780 & 0xFF
	retlw	1780 >> 8

	retlw	1640 & 0xFF
	retlw	1640 >> 8

	retlw	1500 & 0xFF
	retlw	1500 >> 8

	retlw	1200 & 0xFF
	retlw	1200 >> 8

	retlw	1300 & 0xFF
	retlw	1300 >> 8

	retlw	1400 & 0xFF
	retlw	1400 >> 8

	retlw	1500 & 0xFF
	retlw	1500 >> 8

	retlw	1080 & 0xFF
	retlw	1080 >> 8

	retlw	1220 & 0xFF
	retlw	1220 >> 8

	retlw	1360 & 0xFF
	retlw	1360 >> 8

	retlw	1500 & 0xFF
	retlw	1500 >> 8

; Enter with OTIMEHI, OTIMELO containing number of uS of output
; This routine also checks the output value and decides whether to turn the GP output
; on or not
; This is based on whether the GP output is already HI or not to provide some hysteresis
; If LO, turn on if pulse is below 40%, if HI turn off if over 42%
; Normal,  low scale, 40% = 1400uS, 42% = 1420 uS
; Reverse, low scale, 40% = 1600uS, 42% = 1580 uS
; Normal,  Hi  scale, 40% = 1360uS, 42% = 1388 uS
; Reverse, Hi  scale, 40% = 1640uS, 42% = 1612uS

#define	SWITCH_POINT	40

NLON:	equ	1000 + SWITCH_POINT*10
NLOFF:	equ	1000 + (SWITCH_POINT+2)*10
RLON:	equ	2000 - SWITCH_POINT*10
RLOFF:	equ	2000 - (SWITCH_POINT+2)*10
NHON:	equ	800  + SWITCH_POINT*14
NHOFF:	equ	800  + (SWITCH_POINT+2)*14
RHON:	equ	2200 - SWITCH_POINT*14
RHOFF:	equ	2200 - (SWITCH_POINT+2)*14

output:
	BTFSC  PORTA,GPON	; if ( (PORTA.GPON) == 0 )  /* GPOFF */
	GOTO   glowon
				; {
	BTFSS  PORTB,REVERSE	;   if (PORTB.REVERSE) /* Normal */
	GOTO   offrev
				;   {
	MOVLW  NHON & 0xFF	;     gp = 1248 ;
	MOVWF  gpl
	MOVLW  NHON >> 8
	MOVWF  gph

	BTFSS  PORTB,SCALE	;     if ( PORTB.SCALE ) /* scale normal */
	GOTO   offn_ext
				;     {
	MOVLW  NLON & 0xFF	;	gp = 1320 ;
	MOVWF  gpl
	MOVLW  NLON >> 8
	MOVWF  gph
				;     }
offn_ext:
	MOVF   OTIMELO,W	;     gp -= otime ;
	SUBWF  gpl,F
	MOVF   OTIMEHI,W
	SKPC
	ADDLW  1
	SUBWF  gph,F

	BTFSS  gph,7		;     if ( gp >= 0 )
				;     {
	BSF    PORTA,GPON	;	PORTA |= 4 ;
				;     }
				;   }
	GOTO   do_pulse		;   else /* reverse */
				;   {
offrev:
	MOVLW  RHON & 0xFF	;     gp = 1752 ;
	MOVWF  gpl
	MOVLW  RHON >> 8
	MOVWF  gph

	BTFSS  PORTB,SCALE	;     if ( PORTB.SCALE ) /* scale normal */
	GOTO   offr_ext
				;     {
	MOVLW  RLON & 0xFF	;	gp = 1680 ;
	MOVWF  gpl
	MOVLW  RLON >> 8
	MOVWF  gph
				;     }
offr_ext:
	MOVF   OTIMELO,W	;     gp -= otime ;
	SUBWF  gpl,F
	MOVF   OTIMEHI,W
	SKPC
	ADDLW  1
	SUBWF  gph,F

	BTFSC  gph,7		;     if ( gp < 0 )
				;     {
	BSF    PORTA,GPON	;	PORTA.GPON = 1 ;
				;     }
				;   }
	GOTO   do_pulse		;   else
glowon:				;   {
	BTFSS  PORTB,REVERSE	;     if (PORTB.REVERSE) /* Normal */
	GOTO   onrev
				;     {
	MOVLW  NHOFF & 0xFF	;	gp = 1276 ;
	MOVWF  gpl
	MOVLW  NHOFF >> 8
	MOVWF  gph

	BTFSS  PORTB,SCALE	;	if ( PORTB.SCALE ) /* scale normal */
	GOTO   on_n_ext
				;	{
	MOVLW  NLOFF & 0xFF	;	  gp = 1340 ;
	MOVWF  gpl
	MOVLW  NLOFF >> 8
	MOVWF  gph
				;	}
on_n_ext:
	MOVF   OTIMELO,W	;       gp -= otime ;
	SUBWF  gpl,F
	MOVF   OTIMEHI,W
	SKPC
	ADDLW  1
	SUBWF  gph,F

	BTFSC  gph,7		;	if ( gp < 0 )
				;	{
	BCF    PORTA,GPON	;	  PORTA.GPON = 0 ;
				;	}
				;     }
	GOTO   do_pulse		;     else /* reverse */
				;     {
onrev:
	MOVLW  RHOFF & 0xFF	;	gp = 1724 ;
	MOVWF  gpl
	MOVLW  RHOFF >> 8
	MOVWF  gph

	BTFSS  PORTB,SCALE	;	if ( PORTB.SCALE ) /* scale normal */
	GOTO   on_r_ext
				;	{
	MOVLW  RLOFF & 0xFF	;	  gp = 1660 ;
	MOVWF  gpl
	MOVLW  RLOFF >> 8
	MOVWF  gph
				;	}
on_r_ext:
	MOVF   OTIMELO,W	;	gp -= otime ;
	SUBWF  gpl,F
	MOVF   OTIMEHI,W
	SKPC
	ADDLW  1
	SUBWF  gph,F


	BTFSS  gph,7		;	if ( gp >= 0 )
				;	{
	BCF    PORTA,GPON	;	  PORTA.GPON = 0 ;
				;       }
				;     }
do_pulse:
	bcf	INTCON,7		; disable interrupts
	call	set_up_all
	movf	OTIMELO,W
	andlw	0x0F
	sublw	15

	rrf	OTIMEHI,F
	rrf	OTIMELO,F
	rrf	OTIMEHI,F
	rrf	OTIMELO,F
	rrf	OTIMEHI,F
	rrf	OTIMELO,F
	rrf	OTIMEHI,F
	rrf	OTIMELO,F		; OTIMELO contains units of 16 uS

	decf	OTIMELO,F

	addwf	PCL,F
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
	bsf	PORTB,OPBIT	; start the output
oloop:
	call	delay4
	call	delay4
	call	delay4
	nop
	decfsz	OTIMELO,F
	goto	oloop
	call	delay4
	call	delay4
	call	delay4
	call	delay4
	bcf	PORTB,OPBIT
	goto	$+1		; A short delay to allow Output to settle
	btfss	PORTB,OPBIT	; Do NOT retrigger watchdog if OPBIT not cleared
	clrwdt
delay4:
	return


	DW	'('
	DW	'C'
	DW	')'
	DW	' '
	DW	'M'
	DW	'.'
	DW	'P'
	DW	'.'
	DW	'B'
	DW	'l'
	DW	'a'
	DW	'n'
	DW	'd'
	DW	'f'
	DW	'o'
	DW	'r'
	DW	'd'
	DW	' '
	DW	'2'
	DW	'0'
	DW	'0'
	DW	'1'

wait_for_input:
	call	time_update
	call	current_time
	movwf	Acch			; save current time (start time) in Acc
	movf	FSR,W
	movwf	Accl
wait_ip_loop:
;				clrwdt
	btfsc	TIMDONE,0
	return				; and return
	call	time_update
	call	current_time
	subwf	Acch,W
	movwf	Accx
	movf	FSR,W
	subwf	Accl,W
	SKPC
	decf	Accx,F
	movlw	250
	btfsc	INERROR,0
	movlw	125
	addwf	Accx,F
	SKPNC
	goto	wait_ip_loop

; Here we have an input timeout, use 0xFFFF for IPHIGH,IPLOW
; After stopping interrupts
	clrf	INTCON
	movlw	0xFF
	movwf	INPUTLO
	movwf	INPUTHI
	return

start:
	clrwdt
	movlw	20	; number of ram locations to clear
clear_ram_loop:
	clrf	INDF
	incf	FSR,F
	addlw	-1
	SKPZ
	goto	clear_ram_loop

	call	set_up_all
	clrwdt
	clrf	INERROR

restart:
	call	set_up_all
	movlw	0x4F
	option
	clrf	MODE
	clrf	TIMDONE
	movlw	0x90
	movwf	INTCON
	call	wait_for_input

; check for 0xFFFF, representating a timeout	
	movf	INPUTHI,W
	andwf	INPUTLO,W
	addlw	1
	SKPNZ
	goto	timeout

; pulse now measured, next validate it, if invalid discard, wait for next, do NOT restart timer
validate:
	movlw	LOWLIMITA >> 8
	btfss	PORTB,SCALE
	movlw	LOWLIMITB >> 8
	subwf	INPUTHI,W
	movwf	CRESHI
	movlw	LOWLIMITA & 0xFF
	btfss	PORTB,SCALE
	movlw	LOWLIMITB & 0xFF
	subwf	INPUTLO,W
;				movwf	CRESLO
	SKPC
	decf	CRESHI,F
	btfsc	CRESHI,7
	goto	discard

	movlw	HILIMITA >> 8
	btfss	PORTB,SCALE
	movlw	HILIMITB >> 8
	subwf	INPUTHI,W
	movwf	CRESHI
	movlw	HILIMITA & 0xFF
	btfss	PORTB,SCALE
	movlw	HILIMITB & 0xFF
	subwf	INPUTLO,W
;				movwf	CRESLO
	SKPC
	decf	CRESHI,F
	btfss	CRESHI,7
	goto	discard

; pulse validated, generate output
	btfss	INERROR,0
	goto	pout

; Validate ERCOUNT to be between 0 and 10
	movlw	-11
	addwf	ERCOUNT,W
	movlw	10
	SKPNC
	movwf	ERCOUNT
	
	movf	ERCOUNT,W
	SKPZ
	decf	ERCOUNT,F
	SKPZ
	goto	dodefpulse	
	bcf	INERROR,0
pout:
	movf	INPUTHI,W
	movwf	OTIMEHI
	movf	INPUTLO,W
	movwf	OTIMELO
	call	output
	goto	restart

set_up_all:
	bcf	STATUS,RP0
	bcf	STATUS,RP1
	bcf	STATUS,IRP
	clrf	PCLATH
	bcf	PORTB,OPBIT
	movlw	TRISBSET
	TRIS	PORTB
	clrf	PORTB
	movlw	TRISASET
	TRIS	PORTA

	movlw	0x0F			; Configure Pullups, prescale(128) to wdt
	option				; Option register

#ifdef	__16C620A
	movlw	CMCON
	movwf	FSR
	movlw	7
	movwf	INDF
	movlw	VRCON
	movwf	FSR
	clrf	INDF
	movlw	PIE1
	movwf	FSR
	clrf	INDF

#endif


	retlw	0
	
;	org	256

discard:
	btfss	INERROR,0
	goto	restart
; Here if discard and in error
	movlw	10
	movwf	ERCOUNT
	goto	restart

; Here if a timeout occured
; generate a 1.1 mS pulse on the output

timeout:
	bsf	INERROR,0		; Flag error occured
	movlw	10
	movwf	ERCOUNT			; looking for 10 valid pulses

dodefpulse:
	clrf	COUNTER
	btfss	PORTB,REVERSE
	bsf	COUNTER,4
	btfss	PORTB,SCALE
	bsf	COUNTER,3
	btfsc	PORTB,IDLE1
	bsf	COUNTER,2
	btfsc	PORTB,IDLE0
	bsf	COUNTER,1

	movf	COUNTER,W
	call	getparam
	movwf	OTIMELO
	incf	COUNTER,W
	call	getparam
	movwf	OTIMEHI

	call	output
	goto	restart


time_update:
	btfss	INTCON,T0IF		; Has timer 0 overflowed
	return				; No so return
	incf	TIMEH_A,F		; Bump this counter
	bcf	INTCON,T0IF		; Clear the flag
	movf	TIMEH_A,W
	movwf	TIMEH_B			; set second counter
	return				; We have finished

; return the current time in W (high byte) and FSR (low byte)

current_time:
	movf	TMR0,W
	movwf	FSR
	movf	TIMEH_A,W

	btfss	INTCON,T0IF
	return
; Now we sort out the high byte
	btfsc	FSR,7
	return
	addlw	1
	return


	END

